;;  ------------------------------------------------------------------
;; |   FILE           :  finite-function.rkt                          |
;; |   AUTHOR         :  Eugene Wallingford                           |
;; |   CREATION DATE  :  2024/04/08                                   |
;; |   DESCRIPTION    :  An inductive implementation of finite        |
;; |                     functions using Racket functions.  The       |
;; |                     abstract interface hides this detail.        |
;;  ------------------------------------------------------------------

#lang racket
(provide empty-ff extend-ff apply-ff)

(define empty-ff
  (lambda ()
    (lambda (symbol)
      (error 'finite-function "no such key -- ~a" symbol))))

(define extend-ff
  (lambda (sym val ff)
    (lambda (symbol)
      (if (eq? symbol sym)
          val 
          (apply-ff ff symbol)))))

(define apply-ff
  (lambda (ff symbol)
    (ff symbol)))

; ---------------------------------------------------------------------------
